#include "button.ch"
#include "llibg.ch"
#include "inkey.ch"

***********************************************************************
// Manifest Constant Definitions
***********************************************************************
// WReport Class
//---------------------------------------------------------------------
#define RPT_HDR_PAGE       0
#define RPT_HDR_LEVEL1     1
#define RPT_HDR_LEVEL2     2
#define RPT_HDR_LEVEL3     3
#define RPT_HDR_LEVEL4     4
#define RPT_HDR_LEVEL5     5

#define RPT_FTG_PAGE       0
#define RPT_FTG_LEVEL1     1
#define RPT_FTG_LEVEL2     2
#define RPT_FTG_LEVEL3     3
#define RPT_FTG_LEVEL4     4
#define RPT_FTG_LEVEL5     5
#define RPT_FTG_SUMMARY    6

#define RPT_LEVEL1         1
#define RPT_LEVEL2         2
#define RPT_LEVEL3         3
#define RPT_LEVEL4         4
#define RPT_LEVEL5         5
#define RPT_SUMMARY        6

#define RPT_COUNTFIELD     1
#define RPT_TOTALFIELD     2

#define RPT_NEWPAGE        Chr(12)

#define RPT_DISPLAY        .T.
***********************************************************************
// Define command to send code to printer

#command ??? <cString> => ;
     SET CONSOLE OFF ;
   ; SET PRINT ON ;
   ; ?? <cString> ;
   ; SET PRINT OFF ;
   ; SET CONSOLE ON
/*
*/
***********************************************************************
// Note by Author......
// The following list of printer codes is by no means all inclusive of
// the codes that can be used by the WinDos53 report class.  If you
// have a printer that does not use any of these codes, then check your
// printer manual for codes to replace these.  It is suggested, that you
// add codes to this list rather than modify them.
// ********************************************************************
// HP IV si printer codes

#define HP_RESET           "E"               // Reset the printer
#define HP_PORTRAIT        "&l0O"            // Set Portrait mode on
#define HP_LANDSCAPE       "&l1O"            // Set Landscape mode on

#define HP_LOWER_TRAY      "&l4H"            // Select paper from lower tray
#define HP_UPPER_TRAY      "&l1H"            // Select paper from upper tray

#define HP_LETTER          "&l2A"            // Set paper size letter
#define HP_LEGAL           "&l3A"            // Set paper size legal

#define HP_10PITCH         "&k0S"            // Set pitch to 10 cpi (courier)
#define HP_12PITCH         "&k4S"            // Set pitch to 12 cpi
#define HP_16PITCH         "&k2S"            // Set pitch to 16 cpi (condensed)

#define HP_6LPI            "&l6D"            // Set to 6 lines per inch
#define HP_8LPI            "&l8D"            // Set to 8 lines per inch

// Dot Matrix printer codes (Epson compatible)

#define DM_RESET           "@"
#define DM_10PITCH         ""
#define DM_16PITCH         ""
/*
*/
***********************************************************************
// Frame Types
//---------------------------------------------------------------------
// Graphics mode
#define FRAME3D               1
#define WIN3_FRAME            2
#define NOFRAME               3        // Note: both graphic and text
// Text mode
#define FRAME_SINGLE          1
#define FRAME_DOUBLE          2

// box styles
// Graphics mode
#define BOX_INDENT            1
#define BOX_OUTDENT           2
#define BOX_INVERT            3
#define BOX_COLHDR            4        // Note: both graphic and text
// Text Mode
#define BOX_SINGLE            1
#define BOX_DOUBLE            2
/*
*/
***********************************************************************
// TextBox Class
//---------------------------------------------------------------------
// buttons
#define BUTTON_OKAY            1
#define BUTTON_OKAY_CANCEL     2
#define BUTTON_RETRY_CANCEL    3
#define BUTTON_YES_NO          4
#define BUTTON_YES_NO_CANCEL   5
#define BUTTON_CONTINUE_EXIT   6
#define BUTTON_OK_CAN_SETUP    7

// Icons
#define BOX_ICON_HAND          16
#define BOX_ICON_QUESTIONMARK  32
#define BOX_ICON_EXCLAMATION   48
#define BOX_ICON_ASTERISK      64
#define BOX_ICON_PRINTER       80

// Replies
#define BOX_REPLY_YES          1
#define BOX_REPLY_NO           2
#define BOX_REPLY_OKAY         1
#define BOX_REPLY_RETRY        1
#define BOX_REPLY_CANCEL2      2
#define BOX_REPLY_CANCEL3      3
#define BOX_REPLY_CONTINUE     1
#define BOX_REPLY_EXIT         2
/*
*/
***********************************************************************
// Toolbar
//---------------------------------------------------------------------
// Message Positions
#define TBAR_MSG_TOP          1
#define TBAR_MSG_BOTTOM       2
#define TBAR_MSG_LEFT         3
#define TBAR_MSG_RIGHT        4

// Button Separator
#define TBAR_SEPARATOR        1

// Tool Bar Orientation
#define TBAR_HORIZONTAL       1
#define TBAR_VERTICAL         2

// Tool Bar ExitState
#define TBAR_NOEXIT           0
#define TBAR_EXIT             1
/*
*/
***********************************************************************
// SetDefColor
#define WD_CLR_WINDOW         1
#define WD_CLR_DIALOG         2
#define WD_CLR_SAY            3
#define WD_CLR_GET            4
#define WD_CLR_TGET           5
#define WD_CLR_MGET           6
#define WD_CLR_CHECKBOX       7
#define WD_CLR_LISTBOX        8
#define WD_CLR_COMBOBOX       9
#define WD_CLR_RADIOGROUP    10
#define WD_CLR_RADIOBUTTON   11
#define WD_CLR_BROWSE        12
#define WD_CLR_TOPBAR        13
#define WD_CLR_POPUP         14
#define WD_CLR_METERBAR      15
#define WD_CLR_STATUSLINE    16
#define WD_CLR_SCROLLBAR     17
#define WD_CLR_FOLDER        18
#define WD_CLR_TOOLBAR       19
#define WD_CLR_PUSHBUTTON    20

#define WD_CLR_ELEMENTS      20
/*
*/
***********************************************************************
***********************************************************************
// commands
***********************************************************************
***********************************************************************
#command DEFINE TABLE <(db)> AS <oDbf>                            ;
             [VIA <rdd>]                                          ;
             [ALIAS <a>]                                          ;
             [<new: NEW>]                                         ;
             [<ex: EXCLUSIVE>]                                    ;
             [<sh: SHARED>]                                       ;
             [<ro: READONLY>]                                     ;
             [INDEX <(index1)> [, <(indexn)>]]                    ;
             [ RELATED [TO <(alias1)> ON <key1> [,[TO] <(aliasn)> ON <keyn>]]] ;
                                                                  ;
      => dbUseArea( <.new.>, <rdd>, <(db)>, <(a)>,                ;
                    if(<.sh.> .or. <.ex.>, !<.ex.>, NIL), <.ro.>) ;
      [; dbSetIndex( <(index1)> )]                                ;
      [; dbSetIndex( <(indexn)> )]                                ;
      [; dbSetRelation( <(alias1)>,<{key1}>,<"key1">) ] ;
      [; dbSetRelation( <(aliasn)>,<{keyn}>,<"keyn">) ] ;
       ; <oDbf> := WDTableDef(IIf(!<.a.>,<(db)>,<(a)>)) ;
       ; <oDbf>:load()
/*
*/
*----------------------------------------------------------------------
#command LOAD FONT <cFont> TO <aFont> => ;
      <aFont> := GFntLoad(<(cFont)>); GFntSet(<aFont>)

#command RELEASE FONT <aFont> => GFntErase(<aFont>)
*----------------------------------------------------------------------
* SETS
*******
#command SET FONT TO <(cFont)>       => _SetFont( GFntLoad(<(cFont)>) )
#command SET RESOURCES TO <(cFile)>  => GetResource( <(cFile)> )
#command SET PROPERTIES TO <(cFile)> => _Properties( <"cFile"> )
#command SET 3DLOOK <x:ON,OFF>     => _3DLook(if(Upper(<(x)>)=="ON",.T.,.F.))
#command SET WIN95MENUS <x:ON,OFF> => _Win95Menu(if(Upper(<(x)>)=="ON",.T.,.F.))
*----------------------------------------------------------------------
/*
*/
***********************************************************************
*----------------------------------------------------------------------
#command DEFINE WINDOW <oWnd> ;
            FROM <nTop>,<nLeft> TO <nBottom>, <nRight> ;
            [ TITLE <cTitle> ] ;
            [ COLOR <cColorSpec> ] ;
            [ FRAME [TYPE] <cFrame:NONE,WINDOWS> ] ;
            [ <sysmenu:SYSMENU> ] ;
            [ MENU <Menu> ];
            [ ON INIT <bInit> ] ;
=> ;
  <oWnd> := WDWindow():new(<nTop>,<nLeft>,<nBottom>,<nRight>,<cColorSpec>, ;
           [<cTitle>],,;
           [ IIF(UPPER(<(cFrame)>) == "WINDOWS",WIN3_FRAME,NOFRAME) ],;
           <.sysmenu.>,<{bInit}> ) ;
; <oWnd>:menubar := <Menu>

#command ACTIVATE WINDOW <oWnd> => <oWnd>:activate()
/*
*/
*----------------------------------------------------------------------
#command DEFINE DIALOG <oDlg> FROM <nTop>,<nLeft> TO <nBottom>, <nRight> ;
                [ RESOURCE <cResName> ] ;
                [ TITLE <cTitle> ] ;
                [ COLOR <cColorSpec> ] ;
                [ FRAME [TYPE] <cFrame:3DLOOK,WINDOWS> ] ;
                [ <sysmenu:SYSMENU> ] ;
                [ ON INIT <bInit> ] ;
=> ;
   <oDlg> := WDDialog():new(<nTop>,<nLeft>,<nBottom>,<nRight>,<cColorSpec>, ;
             [<cTitle>], ;
             [ IIF(UPPER(<(cFrame)>) == "3DLOOK",1,2) ],[<"cResName">],;
             <.sysmenu.>,<{bInit}> ) ;

#command ACTIVATE DIALOG <oDlg> [<lCenter:CENTERED,CENTRED>] ;
=> ;
   <oDlg>:activate(<.lCenter.>)

#command DEFINE BOX OF <oWnd> ;
            FROM <nTop>,<nLeft> TO <nBottom>,<nRight> ;
            STYLE <nStyle> ;
            [ TITLE <cTitle> ] ;
=> ;
   <oWnd>:AddItem(<nTop>,<nLeft>,<nBottom>,<nRight>, ;
                  <nStyle>, [<cTitle>] )
/*
*/
*----------------------------------------------------------------------
#command DEFINE MENUBAR <oMenu> ;
             [COLOR <cColorSpec>] ;
             [SELECT <nItem>]  ;
=> ;
   <oMenu> := TopBar(0,0,79) ;
 ;[<oMenu>:colorspec := IIf(<.cColorSpec.>,<cColorSpec>,"N/W,W/B,R/W,R+/B,N+/W,N/W")] ;
 ;[<oMenu>:Select(IIf(<.nItem.>,<nItem>,0))]

#command DEFINE POPUPMENU <oMenu> COLOR <cClrspec>   ;
=> ;
   <oMenu> := PopUp();
 ; <oMenu>:colorspec := <cClrspec>

#command DEFINE POPUPITEM OF <oPopUp> ;
             CAPTION <cCaption> ;
             ACTION <bAction> ;
             [MESSAGE <cMsg>] ;
             ID <nID>;
=> ;
   <oPopUp>:AddItem(MenuItem(<cCaption>, <{bAction}>,,[<cMsg>][,<nID>]))

#command DEFINE MENU SEPARATOR OF <oPopUp> ;
=> ;
   <oPopUp>:AddItem(MenuItem( MENU_SEPARATOR ))

#command DEFINE MENUITEM OF <oMenu> ;
             CAPTION <cCaption> ;
             POPUP <oPopUp> ;
             [MESSAGE <cMsg>] ;
             ID <nId> ;
=> ;
   <oMenu>:AddItem(MenuItem(<cCaption>,<oPopUp>,,<cMsg>,<nId>))
/*
*/
*----------------------------------------------------------------------
#command DEFINE MSGBOX <oTextBox> ;
            TITLE <cTitle> ;
            MESSAGE <cMessage> ;
            [ COLOR <cColor> ] ;
            CONFIGURATION <nConfig> ;
=> ;
   <oTextBox> := WDTextBox():New(<cTitle>,<cMessage>, <cColor> ) ;
  ; <oTextBox>:type := <nConfig>

#command ACTIVATE MSGBOX <oTextBox> INTO <nButton> ;
 => ;
   <oTextBox>:show()

/*
*/
*----------------------------------------------------------------------
#command DEFINE METER <oMeter> ;
             TITLE <cTitle> ;
             [ MESSAGE <cMsg> ] ;
             PERCENT <nPct> ;
             [ BARCOLOR <cColor> ] ;
=> ;
       <oMeter> := WDMeter():new(<cTitle>,<cMsg>,<nPct>,<cColor>)

#command ACTIVATE METER <oMeter> ;
=> ;
       <oMeter>:show()

#command CLOSE METER <oMeter> ;
=> ;
       <oMeter>:close()

#command UPDATE METER <oMeter> WITH <nValue> ;
=> ;
       <oMeter>:refresh(<nValue>)

#command RESET METER <oMeter> => <oMeter>:clear()

#command SET MESSAGE1 OF <oMeter> TO <cMessage> ;
=> ;
       <oMeter>:settext(<cMessage>)

#command SET MESSAGE2 OF <oMeter> TO <cMessage> ;
=> ;
       <oMeter>:message(<cMessage>)

/*
*/
*----------------------------------------------------------------------
#command DEFINE TOOLBAR <oToolBar> AT <nTop>,<nLeft> ;
         <cOrient:VERTICAL,HORIZONTAL> ;
         [ FRAME [TYPE] <cFrameType> ] ;
         [ COLOR <cColorSpec> ] ;
         [ DISPLAY TIP <nTipLocn> ] ;
         [ ON INIT <bInit> ] ;
=> ;
       <oToolBar> := WDToolBar():new(<nTop>,<nLeft>, ;
             IIF( UPPER(<(cOrient)>) == "VERTICAL", TBAR_VERTICAL, TBAR_HORIZONTAL ),;
             [<cFrameType>],<nTipLocn>,[<cColorSpec>],<{bInit}>)

#command DEFINE BUTTON OF <oToolBar> ;
             BITMAP <cBMPFile>       ;
             ACTION <bAction>        ;
             [ TOOLTIP <cMessage> ]  ;
=> ;
       <oToolBar>:AddItem( <cBMPFile>, <{bAction}>, [<cMessage>] )

#command DEFINE SEPARATOR OF <oToolBar> ;
=> ;
       <oToolBar>:AddItem(TBAR_SEPARATOR)

#command ACTIVATE TOOLBAR <oToolBar> ;
=> ;
   TBarModal(<oToolBar>)
/*
*/
*----------------------------------------------------------------------
* FOLDER Dialogs
*----------------------------------------------------------------------
#command DEFINE FOLDER <oFldr> ;
            FROM <nTop>,<nLeft> TO <nBottom>,<nRight> ;
            TITLE <cTitle> ;
          [ COLOR <cColorSpec> ] ;
          [ FRAME [TYPE] <cFrame:3DLOOK,WINDOWS> ] ;
          [ <sysmenu:SYSMENU> ] ;
=> ;
  <oFldr> := WDFolder():new(<nTop>,<nLeft>,<nBottom>,<nRight>,;
                            <cTitle>, ;
             [ IIF(UPPER(<(cFrame)>) == "3DLOOK",1,2) ],<cColorSpec>,<.sysmenu.>)

#command DEFINE TAB <oTab> OF <oFldr> ;
           CAPTION <cCaption> ;
           [ MESSAGE <cMsg> ] ;
=>;
   <oTab> := <oFldr>:AddTab(<cCaption>, <cMsg> )

#command ACTIVATE FOLDER <oFldr> ;
=>;
  <oFldr>:activate()
/*
*/
*----------------------------------------------------------------------
* MGET Class
*----------------------------------------------------------------------
// Non-popup
#command DEFINE MEMOGET VAR <cVar> OF <oDlg> ;
           FROM <nTop>,<nLeft> TO <nBottom>,<nRight> ;
           [CAPTION <cCaption>] ;
           [COLOR <cColorSpec> ] ;
           [MESSAGE <cMsg>] ;
=> ;
 MGet():new(<oDlg>,_Get_(<cVar>,<"cVar">),<cMsg>,;
           <cCaption>, <cColorSpec>,.F.,.F.):define(<nTop>,<nLeft>,<nBottom>,<nRight>)

#command REDEFINE MEMOGET VAR <cVar> OF <oDlg> ;
           ID <nId> ;
           [CAPTION <cCaption>] ;
           [<lFrame:FRAME> ] ;
           [COLOR <cColorSpec> ] ;
           [MESSAGE <cMsg>] ;
=> ;
 MGet():new(<oDlg>,_Get_(<cVar>,<"cVar">),<cMsg>, ;
            <cCaption>,<cColorSpec>,.F.,.T.):redefine(<nId>)

// Pop-up
#command DEFINE MEMOGET VAR <cVar> OF <oDlg> ;
           AT <nRow>,<nCol> ;
          [CAPTION <cCaption>] ;
          [<lFrame:FRAME> ] ;
          [COLOR <cColorSpec> ] ;
          [MESSAGE <cMsg>] ;
=> ;
 MGet():new(<oDlg>,_Get_(<cVar>,<"cVar">),<cMsg>, ;
          <cCaption>,<cColorSpec>,<.lFrame.>,.T.):define(<nRow>,<nCol>)
/*
*/
#command REDEFINE MEMOGET VAR <cVar> OF <oDlg> ;
           ID <nId> ;
          [CAPTION <cCaption>];
          [<lFrame:FRAME> ] ;
          [COLOR <cColorSpec> ] ;
          [MESSAGE <cMsg>] ;
=> ;
 MGet():new(<oDlg>,_Get_(<cVar>,<"cVar">),<cMsg>, ;
          <cCaption>,<cColorSpec>,<.lFrame.>,.T.):redefine(<nId>)
/*
*/
*----------------------------------------------------------------------
#command DEFINE TGET <oTGet> OF <oDlg> ;
           FROM <nTop>,<nLeft> TO <nBottom>,<nRight> ;
           TABLE <oDbf> ;
          [<lNoDel:NODELETE>] ;
          [SEPARATOR <cSepChar>] ;
          [MESSAGE <cMsg>] ;
=> ;
 <oTGet> := TGet():new(<oDbf>,<oDlg>,<cMsg>,<cSepChar>,<.lNoDel.>):define(<nTop>,<nLeft>,<nBottom>,<nRight>)

#command REDEFINE TGET <oTGet> OF <oDlg> ;
           ID <nId> ;
           TABLE <oDbf> ;
          [<lNoDel:NODELETE>] ;
          [SEPARATOR <cSepChar>] ;
          [MESSAGE <cMsg>] ;
=> ;
 <oTGet> := TGet():new(<oDbf>,<oDlg>,<cMsg>,<cSepChar><.lNoDel.>):redefine(<nId>)

#command DEFINE FIELD <cFld> OF <oTGet> ;
           TABLE <oDbf> ;
           CAPTION <cCaption> ;
          [COLOR <cColor>    ] ;
          [PICTURE <cPicture>] ;
          [MESSAGE <cMsg>    ] ;
          [WHEN    <bWhen>   ] ;
          [VALID   <bValid>  ] ;
=> ;
    <oTGet>:AddGet(_Get_(<oDbf>:<cFld>,<oDbf>:Alias()+"->"+<"cFld">,<cPicture>,<{bValid}>,<{bWhen}>),;
         <cCaption>,<cMsg>,<cColor>)

#command INITIALIZE TGET <oTGet> OF <oDlg> ;
=> AAdd( <oDlg>:getList, <oTGet> )
/*
*/
*----------------------------------------------------------------------
* Dialog Controls
*----------------------------------------------------------------------
#command DEFINE GET VAR <cVar> OF <oDlg> ;
           AT <nRow>, <nCol> ;
           [<lFrame:FRAME> ] ;
           [<lSecret:SECRET> ] ;
           [COLOR <cColor> ] ;
           [PICTURE <cPict> ] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
=> ;
 <oDlg>:DefGet(<nRow>,<nCol>,_Get_(<cVar>,<"cVar">,<cPict>,<{bValid}>,<{bWhen}>),;
         [<cCaption>],[<cMessage>],[<cColor>],<.lFrame.>,;
                      <.lSecret.>)

#command REDEFINE GET VAR <cVar> OF <oDlg> ;
           ID <nId>;
           [<lFrame:FRAME> ] ;
           [<lSecret:SECRET> ] ;
           [COLOR <cColor> ] ;
           [PICTURE <cPict> ] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
=> ;
 <oDlg>:ReDefGet(<nId>,_Get_(<cVar>,<"cVar">,<cPict>,<{bValid}>,<{bWhen}>), ;
          [<cCaption>],[<cMessage>],[<cColor>],<.lFrame.>,;
                      <.lSecret.>)
/*
*/
*----------------------------------------------------------------------
#command DEFINE SAY VAR <cVar> OF <oDlg> ;
           AT <nRow>, <nCol> ;
           [<lFrame:FRAME> ] ;
           [COLOR <cColor> ] ;
           [PICTURE <cPict> ] ;
           [CAPTION <cCaption>] ;
           [ICON <(cIconFile)> ] ;
=> ;
 <oDlg>:DefSay(<nRow>,<nCol>,_Get_(<cVar>,<"cVar">,<cPict>,NIL,NIL ),;
         [<cCaption>],[<cColor>],<.lFrame.>,<"cIconFile">)

#command REDEFINE SAY VAR <cVar> OF <oDlg> ;
           ID <nId>;
           [<lFrame:FRAME> ] ;
           [COLOR <cColor> ] ;
           [PICTURE <cPict> ] ;
           [CAPTION <cCaption>] ;
           [ICON <(cIconFile)> ] ;
=> ;
 <oDlg>:ReDefSay(<nId>,_Get_(<cVar>,<"cVar">,<cPict>,NIL, NIL ) ;
          [<cCaption>],[<cColor>],<.lFrame.>,<"cIconFile">)
/*
*/
*----------------------------------------------------------------------
#command DEFINE CHECKBOX VAR <cVar> OF <oDlg> ;
           AT <nRow>, <nCol> ;
           [COLOR <cColor>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [ON CHANGE <bAction>] ;
           [CAPTION <cCaption> ] ;
           [MESSAGE <cMessage>] ;
=> ;
 <oDlg>:DefChk(<nRow>,<nCol>,_Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
         <cVar>,<cCaption>,<cMessage>,<cColor>,<{bAction}>)

#command REDEFINE CHECKBOX VAR <cVar> OF <oDlg> ;
           ID <nId> ;
           [COLOR <cColor>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [ON CHANGE <bAction>] ;
           [CAPTION <cCaption> ] ;
           [MESSAGE <cMessage>] ;
=> ;
 <oDlg>:ReDefChk(<nId>,_Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
           <cVar>,<cCaption>,<cMessage>,<cColor>,<{bAction}>)
/*
*/
*----------------------------------------------------------------------
#command DEFINE LISTBOX VAR <cVar> OF <oDlg> ;
           FROM <nTop>,<nLeft> TO <nBottom>, <nRight> ;
           ITEMS <aItems>   ;
           [COLOR <cColor>] ;
           [ON CHANGE <bClick>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
           [<scroll:SCROLLBAR>] ;
=> ;
 <oDlg>:DefLbx(<nTop>,<nLeft>,<nBottom>,<nRight>, ;
         _Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
         <{bClick}>,<cVar>,<aItems>,<cCaption>,<cMessage>,<cColor>,;
         <.scroll.>)

#command REDEFINE LISTBOX VAR <cVar> OF <oDlg> ;
           ID <nId> ;
           ITEMS <aItems>   ;
           [COLOR <cColor>] ;
           [ON CHANGE <bClick>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
           [<scroll:SCROLLBAR>] ;
=> ;
 <oDlg>:ReDefLbx(<nId>,_Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
           <{bClick}>,<cVar>,<aItems>, ;
           <cCaption>,<cMessage>,<cColor>,<.scroll.>)
*** Note:  aItems above is defined as a two-dimension array with
***        each row represented as { <cListItem>, <cListValue> }
/*
*/
*----------------------------------------------------------------------
#command DEFINE COMBOBOX VAR <cVar> OF <oDlg> ;
           FROM <nTop>,<nLeft> TO <nBottom>, <nRight> ;
           ITEMS <aItems>   ;
           [COLOR <cColor>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
           [<scroll:SCROLLBAR>] ;
=> ;
 <oDlg>:DefCbx(<nTop>,<nLeft>,<nBottom>,<nRight>, ;
         _Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
         <cVar>,<aItems>, ;
         <cCaption>,<cMessage>,<cColor>,<.scroll.>)

#command REDEFINE COMBOBOX VAR <cVar> OF <oDlg> ;
           ID <nId> ;
           ITEMS <aItems>   ;
           [COLOR <cColor>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
           [<scroll:SCROLLBAR>] ;
=> ;
 <oDlg>:ReDefCbx(<nId>,_Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
           <cVar>,<aItems>, ;
           <cCaption>,<cMessage>,<cColor>,<.scroll.>)

*** Note:  aItems above is defined as a two-dimension array with
***        each row represented as { <cListItem>, <cListValue> }
/*
*/
*----------------------------------------------------------------------
#command DEFINE PUSHBUTTON VAR <cVar> OF <oDlg> ;
           AT <nRow>,<nCol> ;
           [STYLE <cStyle>] ;
           [COLOR <cColorSpec>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [<noVal:NOVALIDATE>] ;
           [ACTION <bAction>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
=> ;
 <oDlg>:DefBtn(<nRow>,<nCol>,_Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
         <cCaption>,<cMessage>,<cColorSpec>,<cStyle>,<{bAction}>,<.noVal.>)

#command REDEFINE PUSHBUTTON VAR <cVar> OF <oDlg> ;
           ID < nId > ;
           [STYLE <cStyle>] ;
           [COLOR <cColorSpec>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [<noVal:NOVALIDATE>] ;
           [ACTION <bAction>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
=> ;
 <oDlg>:ReDefBtn(<nId>,_Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
           <cCaption>,<cMessage>,<cColorSpec>,<cStyle>,<{bAction}>,<.noVal.>)
/*
*/
*----------------------------------------------------------------------
#command DEFINE RADIOGROUP VAR <cVar> OF <oDlg> ;
           FROM <nTop>,<nLeft> TO <nBottom>, <nRight> ;
           ITEMS <aItems>   ;
           [GROUPCOLOR <cColor1>] ;
           [BUTTONCOLOR <cColor2>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
=> ;
 <oDlg>:DefRad(<nTop>,<nLeft>,<nBottom>,<nRight>,;
         _Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
         <cVar>,<aItems>, ;
         <cCaption>,<cMessage>,<cColor1>,<cColor2>)

#command REDEFINE RADIOGROUP VAR <cVar> OF <oDlg> ;
           ID <nId,...> ;
           ITEMS <aItems>   ;
           [GROUPCOLOR <cColor1>] ;
           [BUTTONCOLOR <cColor2>] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [CAPTION <cCaption>] ;
           [MESSAGE <cMessage>] ;
=> ;
 <oDlg>:ReDefRad({<nId>},_Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),;
            <cVar>,<aItems>,;
            <cCaption>,<cMessage>,<cColor1>,<cColor2>)

*** Note: aItems above is defined as a two-dimensional array with
***       each row representing a button as:
***             {<nRow>,<nCol>,<cCaption>,<nValue>}
/*
*/
*----------------------------------------------------------------------
#command DEFINE BROWSE <oBrw> VAR <cVar> OF <oDlg> ;
           FROM <nTop>,<nLeft> TO <nBottom>,<nRight> ;
           [ALIAS   <cAlias> ] ;
           [FIELDS <FldLst,...> ] ;
           [HEADERS <HdrLst,...> ] ;
           [COLOR <cColorSpec> ] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [<lVScroll:VSCROLL>] ;
           [<lHScroll:HSCROLL>] ;
           [<lNoBar:NOBAR>] ;
           [ON CHANGE <bChange>] ;
           [MESSAGE <cMessage>] ;
=> ;
  <oBrw> := WDBrowse():new():Define(<nTop>,<nLeft>,<nBottom>,<nRight>, ;
                    _Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),<{bChange}>, ;
                    [<(cAlias)>],[{<(FldLst)>}],[{<HdrLst>}], ;
                    <.lVScroll.>,<.lHScroll.>,<.lNoBar.>, ;
                    <cMessage>,<cColorSpec>,<oDlg>)
/*
*/
#command REDEFINE BROWSE <oBrw> VAR <cVar> OF <oDlg> ;
           ID <nId> ;
           [ALIAS   <cAlias> ] ;
           [FIELDS <FldLst,...> ] ;
           [HEADERS <HdrLst,...> ] ;
           [COLOR <cColorSpec> ] ;
           [WHEN <bWhen>] ;
           [VALID <bValid>] ;
           [<lVScroll:VSCROLL>] ;
           [<lHScroll:HSCROLL>] ;
           [<lNoBar:NOBAR>] ;
           [ON CHANGE <bChange>];
           [MESSAGE <cMessage>] ;
=> ;
  <oBrw> := WDBrowse():new():Redefine(<nId>, ;
                    _Get_(<cVar>,<"cVar">,NIL,<{bValid}>,<{bWhen}>),<{bChange}>, ;
                    [<(cAlias)>],[{<(FldLst)>}],[{<HdrLst>}], ;
                    <.lVScroll.>,<.lHScroll.>,<.lNoBar.>, ;
                    <cMessage>,<cColorSpec>,<oDlg>)
/*
*/
*----------------------------------------------------------------------
// Report Definitions

#command DEFINE REPORT <oRpt> ;
           MAXLINES <nMax> ;
          [OUTPUT TO [FILE] <(cFile)>] ;
          [ORIENT <cOrient>] ;
          [PAPER SIZE <cPaper>] ;
          [FONT <cFont>] ;
          [TRAY <cTray>] ;
          [<cLPI> LPI] ;
          [RESET CODE <cResetCode>] ;
=> ;
  <oRpt> := WDReport():new(<nMax>,[<(cFile)>],[<cResetCode>],[<cPaper>], [<cFont>], [<cFont>],[<cTray>],[<cLPI>])

#command DEFINE REPORT GROUP OF <oRpt> ;
           LEVEL <nLevel> ;
           FIELD <cField> ;
           [<before:BLANK LINE BEFORE FOOTING>] ;
           [<after:BLANK LINE AFTER FOOTING>] ;
=> ;
  <oRpt>:ReportGroup(<nLevel>, <"cField">, ;
                IIF(<.before.>,1,0), IIF(<.after.>,1,0) )

#command DEFINE PAGE HEADING OF <oRpt> ;
           LINE <nLine> ;
           COLUMN <nCol> ;
           <cTy:FIELD,VALUE> <cValue> ;
           [PICTURE <cPict>] ;
=> ;
  <oRpt>:HeadingLine(RPT_HDR_PAGE,<nLine>,<nCol>, ;
             IIf(Upper(<(cTy)>)=="VALUE",<"cValue">,<(cValue)>),<cPict>)
/*
*/
#command DEFINE GROUP HEADING OF <oRpt> ;
           LEVEL <nLevel> ;
           LINE <nLine> ;
           COLUMN <nCol> ;
           <cTy:FIELD,VALUE> <cValue> ;
           [PICTURE <cPict>] ;
=> ;
  <oRpt>:HeadingLine(<nLevel>,<nLine>,<nCol>, ;
             IIf(Upper(<(cTy)>)=="VALUE",<"cValue">,<(cValue)>),<cPict>)

#command DEFINE PAGE FOOTING OF <oRpt> ;
           LINE <nLine> ;
           COLUMN <nCol> ;
           <cTy:FIELD,VALUE> <cValue> ;
           [PICTURE <cPict>] ;
=> ;
  <oRpt>:FootingLine(RPT_FTG_PAGE,<nLine>,<nCol>, ;
             IIf(Upper(<(cTy)>)=="VALUE",<"cValue">,<(cValue)>),<cPict>)

#command DEFINE GROUP FOOTING OF <oRpt> ;
           LEVEL <nLevel> ;
           LINE <nLine> ;
           COLUMN <nCol> ;
           <cTy:FIELD,VALUE> <cValue> ;
           [PICTURE <cPict>] ;
=> ;
  <oRpt>:FootingLine(<nLevel>,<nLine>,<nCol>, ;
             IIf(Upper(<(cTy)>)=="VALUE",<"cValue">,<(cValue)>),<cPict>)

#command DEFINE PAGE BREAK OF <oRpt> ;
           LEVEL <nLevel> ;
=> ;
  <oRpt>:FootingLine(<nLevel>,99,0,RPT_NEWPAGE)

#command DEFINE COUNT FIELD <cFld> OF <oRpt> ;
           RESET [ON LEVEL] <nLevel> ;
=> ;
  <oRpt>:TotalField(<"cFld">,RPT_COUNTFIELD,<nLevel>)
/*
*/
#command DEFINE TOTAL FIELD <cFld> OF <oRpt> ;
           SUM <cSum> ;
           RESET [ON LEVEL] <nLevel> ;
=> ;
  <oRpt>:TotalField(<"cFld">,RPT_TOTALFIELD,<nLevel>,<"cSum">)

#command DEFINE CALC FIELD <cFld> OF <oRpt> ;
           EXPRESSION <cExp> ;
=> ;
  <oRpt>:CalcField(<"cFld">,<"cExp">)

#command DEFINE BODY OF <oRpt> ;
           LINE <nLine> ;
           COLUMN <nCol> ;
           <cTy:VALUE,FIELD> <cValue> ;
          [PICTURE <cPict> ] ;
=> ;
  <oRpt>:BodyLine(<nLine>, <nCol>, ;
             IIf(Upper(<(cTy)>)=="VALUE",<"cValue">,<(cValue)>),<cPict>)

#command ACTIVATE REPORT <oRpt> [<disp:PREVIEW>];
=> ;
  <oRpt>:Print(<.disp.>)
***********************************************************************
