************************************************************************
*** Program TESTMTR.PRG
************************************************************************
#include "windos.ch"
#include "box.ch"
************************************************************************
/*  Demonstration of a progress meter attached to window.
*/
/*  Copyright (c) 1996 Bryan Duchesne
    This program may be used as a model for development but it may
    not be sold to anyone or used for purposes other than modelling
    applications

    The sample demonstrates setting up a progress meter to be displayed
    when a menu item is selected.

    The menu in this program is set up in the traditional Clipper 5.3
    method.
*/
************************************************************************
STATIC nCount, oMeter, oWnd, oDlg
PROCEDURE Main
   LOCAL oMenu
      // Set Graphics On
      SET VIDEOMODE TO LLG_VIDEO_VGA_640_480_16

      // Establish mouse events
      SET 3DLOOK ON

      SET( _SET_EVENTMASK, INKEY_ALL )
      MSetCursor(.T.)

      DEFINE WINDOW oWnd FROM 0,0 TO MaxRow()-1,MaxCol() ;
         TITLE "Progress Meter Demonstration" ;
         FRAME TYPE NONE ;
         MENU SetMenu(oWnd)

      ACTIVATE WINDOW oWnd

   RETURN


FUNCTION SetMenu(oWnd)
   LOCAL oTopBar, oPopUp
      oTopBar := TopBar(0,0,79)
      oTopBar:ColorSpec :="N/W,W/B,R/W,R+/B,N+/W,N/W"
      oTopBar:Select(0)

      // Define File Menu
      oPopUp := PopUp()
      oPopUp :ColorSpec :="N/W,W/B,R/W,R+/B,N+/W,N/W"
      oPopUp:AddItem(MenuItem( "&Test Meter" ,{|| ShowMeter() },,"Show Meter Demo",101))

      oPopUp:AddItem(MenuItem( "E&xit" ,{|| oWnd:end() },,"Exit Program",102))

      oTopBar:AddItem( MenuItem ( "&File",oPopUp ) )

   RETURN ( oTopBar )


STATIC FUNCTION ShowMeter()

      DEFINE METER oMeter ;
         TITLE "Progress Meter Demo" ;
         PERCENT 100

      ACTIVATE METER oMeter

      SET MESSAGE1 OF oMeter to "Counting from 1 to 100"

      FOR nCount = 1 TO 100
        UPDATE METER oMeter WITH nCount
        InKey(.2)
      NEXT

      InKey(2)

      RESET METER oMeter

      SET MESSAGE1 OF oMeter to "Counting Again"

      FOR nCount = 1 TO 100
        UPDATE METER oMeter WITH nCount
        inkey(.2)
      NEXT

      CLOSE METER oMeter
   RETURN ( NIL )
