#include "windos.ch"
MemVar   PrtLPI,  PrtPitch,  PrtPaper,  PrtOrient, PrtReset

STATIC oCustData, oCustFin, oCustNote, oOrders, oInvoices
STATIC oTerms,    oDisc

/****
  This program is used to maintain the customer table.  There are
  3 tables making up the customer data.

     WDCUST.DBF
     WDFIN.DBF
     WDNOTE.DBF   WDNOTE.DBT

  We use several other tables to perform certain validations and to
  obtain other information.

****/

PROCEDURE WDDCust
   LOCAL oDlg, oBrw
   LOCAL cDummy, cBrw

      // Open the tables required for this operation
      //    and set the relations
      DEFINE TABLE WdInv   AS oInvoices INDEX WdInv   NEW
      DEFINE TABLE WdOrdh  AS oOrders   INDEX WdOrdh  NEW
      DEFINE TABLE WdTerms AS oTerms    INDEX WdTerms NEW
      DEFINE TABLE WdDisc  AS oDisc     INDEX WdDisc  NEW
      DEFINE TABLE WdFin   AS oCustFin  INDEX WdFin   NEW
      DEFINE TABLE WdNote  AS oCustNote INDEX WdNote  NEW
      DEFINE TABLE WdCust  AS oCustData INDEX WdCust  NEW ;
          RELATE TO WdFin   ON WdCust->CustNo ;
          RELATE TO WdNote  ON WdCust->CustNo

      DEFINE DIALOG oDlg FROM 1,1 TO 23,60 ;
           TITLE "Customer Data" ;
           SYSMENU

      oCustData:select()

      DEFINE BROWSE oBrw VAR cBrw OF oDlg ;
           FROM 4,2 TO 18,54 ;
           ALIAS WdCust ;
           FIELDS WdCust->CustNo,WdCust->Name,WdCust->Address, ;
                  WdCust->City,WdCust->Prov, WdCust->PostCode ;
           HEADERS "Number","Name","Address","City","State","Zip" ;
           VSCROLL HSCROLL ;
           NOBAR ;
           MESSAGE "Select Customer"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 3 ;
           ACTION {|| oDlg:end() } ;
           CAPTION "Close" ;
           MESSAGE "Push Here to Exit"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 14 ;
           ACTION {|| PrtReport(oBrw) } ;
           CAPTION "Print" ;
           MESSAGE "Push Here to Print Customer List"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 25 ;
           ACTION {|| WDDCustData(.F.) } ;
           CAPTION "Modify" ;
           MESSAGE "Push Here to Modify Selected Customer"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 36 ;
           ACTION {|| WDDCustData(.T.),oDlg:refresh(),oBrw:gotop(),oBrw:refresh() } ;
           CAPTION "Add" ;
           MESSAGE "Push Here to Add New Customer"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 47 ;
           ACTION {|| DelCust(), oDlg:refresh(),oBrw:gotop(), oBrw:refresh() } ;
           CAPTION "Delete" ;
           MESSAGE "Push Here to Delete Selected Customer"

      ACTIVATE DIALOG oDlg CENTERED
      CLOSE DATABASES
   RETURN

STATIC PROCEDURE PrtReport(oBrw)
      IF ReportDlg("Customer List") = 1
        oBrw:report("Customer List",35,PrtReset,PrtOrient,PrtPitch,PrtLPI)
      ENDIF
   RETURN

PROCEDURE WDDCustData( lNew )
   LOCAL oFldr, oTab1, oTab2, oTab3
   LOCAL cBtn1, cBtn2, cBtn1a, cBtn2a
   LOCAL aTerms, aDisc

      aTerms := LoadItems(oTerms)      // Load items array for terms
      aDisc  := LoadItems(oDisc)       // Load items array for discounts

      IF lNew
        oCustData:empty()
        oCustFin:empty()
        oCustNote:empty()
      ELSE
        oCustData:load()
        oCustFin:load()
        oCustNote:load()
      ENDIF

      DEFINE FOLDER oFldr FROM 5,10 TO 21,60 ;
         TITLE "Customer Data" ;
         SYSMENU

      // Define the folder tabs
      // **********************
      // Tab 1 - Personal Data

      DEFINE TAB oTab1 OF oFldr CAPTION "Location" ;
        MESSAGE "Customer Name and Address Information"

      DEFINE BOX OF oTab1 ;
         FROM 0,1 TO 14,49 ;
         STYLE BOX_INVERT

      DEFINE GET VAR oCustData:custno OF oTab1 ;
         AT 0, 15 ;
         FRAME ;
         WHEN ( lNew ) ;
         COLOR "N/W,W+/B" ;
         CAPTION "Number:" ;
         MESSAGE "Enter the Customer Number"

      DEFINE GET VAR oCustData:Name OF oTab1 ;
         AT 2, 15 ;
         FRAME ;
         COLOR "N/W,W+/B" ;
         CAPTION "Name:" ;
         MESSAGE "Enter the Customer's Name"

      DEFINE GET VAR oCustData:Address OF oTab1 ;
         AT  4,15 ;
         FRAME ;
         COLOR "N/W,W+/B";
         CAPTION "Address:" ;
         MESSAGE "Enter the Customer's Street Address"

      DEFINE GET VAR oCustData:City OF oTab1 ;
         AT  6,15 ;
         FRAME ;
         COLOR "N/W,W+/B" ;
         CAPTION "City:" ;
         MESSAGE "Enter the Customer's City"

      DEFINE GET VAR oCustData:Prov OF oTab1 ;
         AT  8,15 ;
         FRAME ;
         COLOR "N/W,W+/B" ;
         CAPTION "State:" ;
         MESSAGE "Enter the Customer's State or Province"

      DEFINE GET VAR oCustData:Postcode OF oTab1 ;
         AT  8,30 ;
         FRAME ;
         COLOR "N/W,W+/B" ;
         CAPTION "Zip:" ;
         MESSAGE "Enter the Customer's ZIP or Postal Code"

      DEFINE PUSHBUTTON VAR cBtn1 OF oTab1 ;
         AT 10, 5 ;
         ACTION {|| oFldr:end() } ;
         CAPTION "Close" ;
         MESSAGE "Click here to Close this Dialog"

      DEFINE PUSHBUTTON VAR cBtn1a OF oTab1 ;
         AT 10, 15 ;
         ACTION {|| SaveCust( lNew, oFldr) } ;
         CAPTION "Save" ;
         MESSAGE "Click here to Save the above data"

      // Tab 2 - Financial Data
      DEFINE TAB oTab2 OF oFldr CAPTION "Financial" ;
         MESSAGE "Customer Financial Information"

      DEFINE BOX OF oTab2 ;
         FROM 0,1 TO 14,49 ;
         STYLE BOX_INVERT

      DEFINE SAY VAR oCustData:Name OF oTab2 ;
         AT 2, 10 ;
         FRAME ;
         COLOR "N/W,N/W" ;
         CAPTION "Name:"

      DEFINE GET VAR oCustFin:Limit OF oTab2 ;
         AT 2,20 ;
         FRAME ;
         PICTURE "99999.99" ;
         COLOR "N/W,W+/B" ;
         CAPTION "Credit Limit:" ;
         MESSAGE "Enter the Customer's Credit Limit"

      DEFINE SAY VAR oCustFin:Balance OF oTab2 ;
         AT 2,40 ;
         FRAME ;
         PICTURE "99999.99" ;
         COLOR "N/W,N+/W" ;
         CAPTION "Balance:"

      DEFINE COMBOBOX VAR oCustFin:terms OF oTab2 ;
         FROM 4,20 TO 10,40 ;
         ITEMS aTerms ;
         CAPTION "Terms:" ;
         MESSAGE "Select Applicable Terms from Above List"

      DEFINE COMBOBOX VAR oCustFin:disc OF oTab2 ;
         FROM 6,20 TO 12,40 ;
         ITEMS aDisc ;
         CAPTION "Discount:" ;
         MESSAGE "Select Applicable Discount from Above List"

      DEFINE PUSHBUTTON VAR cBtn2 OF oTab2 ;
         AT 10, 5 ;
         ACTION {|| oFldr:end() } ;
         CAPTION "Close" ;
         MESSAGE "Click here to Close this Dialog"

      DEFINE PUSHBUTTON VAR cBtn2a OF oTab2 ;
         AT 10, 15 ;
         ACTION {|| oCustFin:save() } ;
         CAPTION "Save" ;
         MESSAGE "Click Save to Save the Above data"

      // Tab 3 - Customer Notes
      DEFINE TAB oTab3 OF oFldr CAPTION "Notes" ;
         MESSAGE "Notes about the Customer"

      DEFINE PUSHBUTTON VAR cBtn2 OF oTab3 ;
         AT  9, 5 ;
         ACTION {|| oFldr:end() } ;
         CAPTION "Close" ;
         MESSAGE "Click here to Close this Dialog"

      DEFINE PUSHBUTTON VAR cBtn2a OF oTab3 ;
         AT  9, 15 ;
         ACTION {|| oCustNote:save() } ;
         CAPTION "Save" ;
         MESSAGE "Click Save to Save the Above data"

      DEFINE MEMOGET VAR oCustNote:notes OF oTab3 ;
         FROM 1,2 TO  9, 48 ;
         CAPTION "Customer Notes" ;
         COLOR "N/W,W+/B" ;
         MESSAGE "Enter Customer Notes"

      ACTIVATE FOLDER oFldr
   RETURN

FUNCTION SaveCust( lNew, oDlg )
      IF Empty( oCustData:custno )
        MsgBeep()
        MsgOk("Customer Information","Customer Number Must be Entered")
        oDlg:GetNext( 1 )
      ELSEIF DupCustNo(lNew) .AND. lNew
        oDlg:GetNext( 1 )
      ELSEIF Empty( oCustData:name )
        MsgBeep()
        MsgOk("Customer Information","Customer Name Must be Entered")
        oDlg:GetNext( 2 )
      ELSEIF Empty( oCustData:City )
        MsgBeep()
        MsgOk("Customer Information","Customer City Must be Entered")
        oDlg:GetNext( 4 )
      ELSE
        IF lNew
          oCustData:append()
          oCustFin:custno := oCustData:custno
          oCustFin:append()
          oCustFin:save()
          oCustNote:custno := oCustData:custno
          oCustNote:append()
          oCustNote:save()
        ENDIF
        oCustData:save()
      ENDIF
   RETURN ( NIL )

FUNCTION DelCust()
      oCustData:load()
      // No orphans allowed !!!
      IF oOrders:seek( oCustData:Custno )
        MsgBeep()
        MsgOk("Delete Customer","Cannot Delete Customer;;" + ;
                                   "Currently in Use in Orders")
      ELSEIF oInvoices:seek( oCustData:CustNo )
        MsgBeep()
        MsgOk("Delete Customer","Cannot Delete Customer;;" + ;
                                   "Currently in Use in Accounts Receivable")
      ELSE
        DelRecord( oCustData )
        DelRecord( oCustFin )
        DelRecord( oCustNote )
      ENDIF
   RETURN ( NIL )

FUNCTION LoadItems(oDbf)
   LOCAL aItems := {}
      oDbf:goTop()
      WHILE !( oDbf:eof() )
        oDbf:load()
        AAdd( aItems, { oDbf:desc, oDbf:code } )
        oDbf:skip()
      ENDDO
   RETURN ( aItems )

STATIC FUNCTION DupCustNo(lNew)
   LOCAL nRec := oCustData:recno()
   LOCAL lDupRec := .T.
      lDupRec := oCustData:seek(oCustData:custno)
      oCustData:goto(nRec)
      IF lDupRec .AND. lNew
        MsgTone()
        MsgOk("Add Customer","Customer Number Already Exists")
      ENDIF
   RETURN ( lDupRec )
