#include "windos.ch"
MemVar   PrtLPI,  PrtPitch,  PrtPaper,  PrtOrient, PrtReset

STATIC oDisc

/***
  This program is used to maintain the table of discounts
  Very simple application

***/
PROCEDURE WDDDisc
   LOCAL oDlg, oBrw
   LOCAL cDummy, cBrw

      // Open the tables required for this operation
      //    and set the relations
      DEFINE TABLE WdDisc  AS oDisc    INDEX WdDisc NEW

      DEFINE DIALOG oDlg FROM 1,1 TO 23,60 ;
           TITLE "Discount Table" ;
           FRAME TYPE WINDOWS ;
           SYSMENU

      DEFINE BROWSE oBrw VAR cBrw OF oDlg ;
           FROM 4,2 TO 18,54 ;
           ALIAS WdDisc  ;
           FIELDS WdDisc->Code,WdDisc->Desc,WdDisc->Percent ;
           HEADERS "Discount;Code",";Description","Discount;Percent" ;
           VSCROLL ;
           NOBAR ;
           MESSAGE "Select Item"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 3 ;
           ACTION {|| oDlg:end() } ;
           CAPTION "Close" ;
           MESSAGE "Push Here to Exit"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 14 ;
           ACTION {||PrtReport(oBrw) } ;
           WHEN !( oDisc:eof() ) ;
           CAPTION "Print" ;
           MESSAGE "Push Here to Print Discount List"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 25 ;
           ACTION {|| WDDDisData(.F.),oBrw:refresh() } ;
           WHEN !( oDisc:eof() ) ;
           CAPTION "Modify" ;
           MESSAGE "Push Here to Modify Selected Item"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 36 ;
           ACTION {|| WDDDisData(.T.),oBrw:gotop(),oBrw:refresh() } ;
           CAPTION "Add" ;
           MESSAGE "Push Here to Add New Item"

      ACTIVATE DIALOG oDlg CENTERED
      CLOSE DATABASES
   RETURN

STATIC PROCEDURE PrtReport(oBrw)
      IF ReportDlg("Discount Table") = 1
        oBrw:report("Discount Table",35,PrtReset,PrtOrient,PrtPitch,PrtLPI)
      ENDIF
   RETURN

PROCEDURE WDDDisData( lNew )
   LOCAL oDlg, cBtn1, cBtn2

      IF lNew
        oDisc:empty()
        oDisc:code := GetNextCode( oDisc )
      ELSE
        oDisc:load()
      ENDIF

      DEFINE DIALOG oDlg FROM 5,10 TO 19,60 ;
         TITLE "Discount Information"

      DEFINE SAY VAR oDisc:Code OF oDlg ;
         AT 1, 15 ;
         FRAME ;
         COLOR "N/W,W/B" ;
         CAPTION "Code:"

      DEFINE GET VAR oDisc:Desc OF oDlg ;
         AT  3,15 ;
         FRAME ;
         COLOR "N/W,W/B";
         CAPTION "Description:" ;
         MESSAGE "Enter the description for this Item"

      DEFINE GET VAR oDisc:Percent OF oDlg ;
         AT  5,15 ;
         FRAME ;
         COLOR "N/W,W/B" ;
         CAPTION "Percent:" ;
         PICTURE "999" ;
         MESSAGE "Enter the Discount Percentage"

      DEFINE PUSHBUTTON VAR cBtn1 OF oDlg ;
         AT 11, 5 ;
         ACTION {|| oDlg:end() } ;
         CAPTION "Close"

      DEFINE PUSHBUTTON VAR cBtn2 OF oDlg ;
         AT 11, 16 ;
         ACTION SaveDisc( lNew, oDlg ) ;
         CAPTION "Save"

      ACTIVATE DIALOG oDlg
   RETURN

STATIC FUNCTION SaveDisc( lNew, oDlg )
      IF Empty(oDisc:desc)
        MsgBeep()
        MsgOk("Discount Data","Description Must be Entered")
        oDlg:GetNext( 1 )
      ELSEIF Empty( oDisc:percent )
        MsgBeep()
        MsgOk("Discount Data","Percentage Must be Entered")
        oDlg:GetNext( 2 )
      ELSE
        SaveRecord( lNew, oDlg, oDisc )
      ENDIF
   RETURN ( NIL )
