#include "windos.ch"
MemVar   PrtLPI,  PrtPitch,  PrtPaper,  PrtOrient, PrtReset

STATIC oInv, oOrders

/***
  This program maintains our inventory table.  It uses another table
  to perform certain validations.
***/

PROCEDURE WDDInv
   LOCAL oDlg, oBrw
   LOCAL cDummy, cBrw

      // Open the tables required for this operation
      //    and set the relations
      DEFINE TABLE WdOrdd AS oOrders  INDEX WdOrdd1, WdOrdd2 NEW
      DEFINE TABLE WdInv  AS oInv     INDEX WdInv  NEW

      DEFINE DIALOG oDlg FROM 1,1 TO 23,60 ;
           TITLE "Inventory Data" ;
           SYSMENU

      DEFINE BROWSE oBrw VAR cBrw OF oDlg ;
           FROM 4,2 TO 18,54 ;
           ALIAS WdInv ;
           FIELDS WdInv->Partno,WdInv->Desc,WdInv->UnitPrice, ;
                  WdInv->Balance ;
           HEADERS "Part;Number","Product;Description","Unit;Price","On;Hand" ;
           VSCROLL HSCROLL ;
           NOBAR ;
           MESSAGE "Select Item"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 3 ;
           STYLE "[]" ;
           ACTION {|| oDlg:end() } ;
           CAPTION "Close" ;
           MESSAGE "Push Here to Exit"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 14 ;
           STYLE "[]" ;
           ACTION {|| PrtReport(oBrw)} ;
           WHEN !( oInv:eof() ) ;
           CAPTION "Print" ;
           MESSAGE "Push Here to Print Inventory List"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 25 ;
           STYLE "[]" ;
           ACTION {|| oInv:load(), WDDInvData(.F.),oBrw:refresh() } ;
           WHEN !( oInv:eof() ) ;
           CAPTION "Modify" ;
           MESSAGE "Push Here to Modify Selected Item"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 36 ;
           STYLE "[]" ;
           ACTION {|| oInv:Empty(), WDDInvData(.T.),oDlg:refresh(),oBrw:gotop(),oBrw:refresh() } ;
           CAPTION "Add" ;
           MESSAGE "Push Here to Add New Item"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 47 ;
           STYLE "[]" ;
           ACTION {|| DelPart(),oDlg:refresh(), oBrw:gotop(), oBrw:refresh() } ;
           WHEN !( oInv:eof() ) ;
           CAPTION "Delete" ;
           MESSAGE "Push Here to Delete Selected Item"

      ACTIVATE DIALOG oDlg CENTERED
      CLOSE DATABASES
   RETURN

STATIC PROCEDURE PrtReport(oBrw)
      IF ReportDlg("Inventory List") = 1
        oBrw:report("Inventory List",35,PrtReset,PrtOrient,PrtPitch,PrtLPI)
      ENDIF
   RETURN

PROCEDURE WDDInvData(lNew)
   LOCAL oDlg, cBtn1, cBtn2

      DEFINE DIALOG oDlg FROM 5,10 TO 21,60 ;
         TITLE "Inventory Data" ;
         SYSMENU

      DEFINE BOX OF oDlg ;
         FROM 2, 1 TO 15,50 ;
         STYLE BOX_INVERT

      DEFINE GET VAR oInv:PartNo OF oDlg ;
         AT 1, 15 ;
         FRAME ;
         WHEN (lNew ) ;
         COLOR "N/W,W/B" ;
         CAPTION "Part No:" ;
         MESSAGE "Enter Part Number for this Item"

      DEFINE GET VAR oInv:Desc OF oDlg ;
         AT  3,15 ;
         FRAME ;
         COLOR "N/W,W/B";
         CAPTION "Description:" ;
         MESSAGE "Enter the Description for this Item"

      DEFINE GET VAR oInv:UnitPrice OF oDlg ;
         AT  5,15 ;
         FRAME ;
         COLOR "N/W,W/B" ;
         CAPTION "Price:" ;
         PICTURE "9999.99" ;
         MESSAGE "Enter the Selling Unit Price for this item"

      DEFINE GET VAR oInv:Balance OF oDlg ;
         AT  7,15 ;
         FRAME ;
         WHEN ( lNew ) ;
         COLOR "N/W,W/B" ;
         CAPTION "On Hand:" ;
         PICTURE "99999" ;
         MESSAGE "Enter the Opening Inventory Count for this Item"

      DEFINE MEMOGET VAR oInv:notes OF oDlg ;
         AT  9,15 ;
         CAPTION "Notes:" ;
         FRAME ;
         COLOR "N/W,GR+/R" ;
         MESSAGE "Notes about this item"

      DEFINE PUSHBUTTON VAR cBtn1 OF oDlg ;
         AT 11, 5 ;
         STYLE "[]" ;
         ACTION {|| oDlg:end() } ;
         CAPTION "Close" ;
         MESSAGE "Click Close to End this Dialog"

      DEFINE PUSHBUTTON VAR cBtn2 OF oDlg ;
         AT 11, 16 ;
         STYLE "[]" ;
         ACTION SavePart( lNew, oDlg) ;
         CAPTION "Save" ;
         MESSAGE "Click Save to Save the Data"

      ACTIVATE DIALOG oDlg
   RETURN

FUNCTION SavePart( lNew, oDlg)
      IF Empty( oInv:partno) .AND. lNew
        MsgBeep()
        MsgOk("Inventory Data","Part Number Must be Entered")
        oDlg:GetNext( 1 )
      ELSEIF DupPart() .AND. lNew
        MsgTone()
        MsgOk("Add Inventory Item","Item Number Already Exists")
        oDlg:GetNext( 1 )
      ELSEIF Empty( oInv:unitprice )
        MsgTone()
        MsgOk("Add Inventory Item","Unit Price Must be Entered")
        oDlg:GetNext( 3 )
      ELSE
        SaveRecord( lNew, oDlg, oInv )
      ENDIF
   RETURN ( NIL )

STATIC FUNCTION DupPart()
   LOCAL nRec := oInv:recno()
   LOCAL lSuccess
      lSuccess := oInv:seek(oInv:partno)
      oInv:goto(nRec)
   RETURN ( lSuccess )

// No orphans allowed !
STATIC FUNCTION DelPart()
   LOCAL nOldOrder
   LOCAL lFound
      oInv:load()
      nOldOrder := oOrders:setOrder(2)
      lFound := oOrders:seek( oInv:partno )
      IF lFound
        MsgBeep()
        MsgOk("Delete Part Number","Cannot Delete Part Number;;" + ;
                                   "Currently in Use in Orders")
      ELSE
        DelRecord( oInv )
      ENDIF
      oOrders:setorder( nOldOrder )
   RETURN ( NIL )
