#include "windos.ch"
MemVar   PrtLPI,  PrtPitch,  PrtPaper,  PrtOrient, PrtReset

STATIC oBrw
STATIC oCustData, oArData

/***
  This program is used to view the open Accounts Receivable records
***/

PROCEDURE WDDInvVw
   LOCAL cDummy, cBrw, aItems, nOrder := 1, aOrder, oDlg

      // The array below is used for the radio buttons
      //   usage of each element is noted.
      // ------------------------------------------------------------
      //             r, c,  caption    val sblock
      //            -- --   --------   --- --------------------
      aOrder  := { { 1,16, "Customer" ,"1",{||SetOrder(1,oBrw)} } , ;
                   { 1,30, "Invoice " ,"2",{||SetOrder(2,oBrw)} }  }

      // Open the tables required for this operation
      //    and set the relations
      DEFINE TABLE WdCust AS oCustData INDEX WdCust NEW
      DEFINE TABLE WdAccts AS oArData INDEX WdAccts1, WdAccts2 NEW ;
         RELATE TO WdCust ON WdAccts->CustNo

      DEFINE DIALOG oDlg FROM 0,0 TO 20,70 ;
           TITLE "Accounts Receivable"

      DEFINE BROWSE oBrw VAR cBrw OF oDlg ;
           FROM 3,2 TO 18,66 ;
           ALIAS WdAccts ;
           FIELDS WdAccts->CustNo,WdCust->Name,WdAccts->InvoiceNo, ;
                  WdAccts->Date, WdAccts->Net ;
           HEADERS "Number","Name","Invoice;No","Invoice;Date","Invoice;Total" ;
           VSCROLL ;
           MESSAGE "Browsing Invoices"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 3 ;
           ACTION {|| oDlg:end() } ;
           CAPTION "Close" ;
           MESSAGE "Push Here to Exit"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 50 ;
           WHEN ! (oArData:eof()) ;
           ACTION {|| PrtReport(oBrw)} ;
           CAPTION "Print" ;
           MESSAGE "Push Here to Print Invoice List"

      DEFINE RADIOGROUP VAR nOrder OF oDlg ;
         FROM 0,15 TO 2,44 ;
         ITEMS aOrder ;
         CAPTION "Browse Sequence" ;
         MESSAGE "Choose Browse Sequence"

      ACTIVATE DIALOG oDlg CENTERED

      CLOSE DATABASES
   RETURN

STATIC PROCEDURE PrtReport(oBrw)
      IF ReportDlg("Invoice List") = 1
        oBrw:report("Invoice List",35,PrtReset,PrtOrient,PrtPitch,PrtLPI,,,.T.)
      ENDIF
   RETURN

FUNCTION SetOrder(nOrder, oBrw )
      oArData:setorder(nOrder)
      oBrw:gotop()
      oBrw:refresh()
   RETURN ( NIL )
