#include "windos.ch"
#include "getexit.ch"
MemVar   PrtLPI,  PrtPitch,  PrtPaper,  PrtOrient, PrtReset

STATIC oBrw
STATIC oCustData, oCustFin, oOrdHdr, oOrdDetl, oTerms, oDisc, oInvent
STATIC nTotalOrd, nTotalDisc, nNetOrder

/***

  Data entry for customer orders.  Uses several features, most notable
  the TGet class.

***/
PROCEDURE WDDOrd
   LOCAL oDlg
   LOCAL cDummy, cBrw

      // Open the tables required for this operation
      //    and set the relations
      DEFINE TABLE WdTerms AS oTerms    INDEX WdTerms NEW
      DEFINE TABLE WdDisc AS oDisc      INDEX WdDisc NEW
      DEFINE TABLE WdFin AS oCustFin    INDEX WdFin NEW ;
         RELATE TO WdTerms ON WdFin->Terms ;
                TO WdDisc ON WdFin->Disc
      DEFINE TABLE WdCust AS oCustData INDEX WdCust NEW ;
         RELATE TO WdFin ON WdCust->CustNo
      DEFINE TABLE WdInv   AS oInvent   INDEX WdInv   NEW
      DEFINE TABLE WdOrdH AS oOrdHdr    INDEX WdOrdH NEW ;
         RELATE TO WdCust ON WdOrdH->CustNo
      DEFINE TABLE WdOrdD AS oOrdDetl   INDEX WdOrdD1, WdOrdD2 NEW ;
         RELATE TO WdInv ON WdOrdD->Partno

      DEFINE DIALOG oDlg FROM 1,1 TO 23,60 ;
           TITLE "Customer Orders" ;
           SYSMENU

      DEFINE BROWSE oBrw VAR cBrw OF oDlg ;
           FROM 4,2 TO 18,54 ;
           ALIAS WdOrdH ;
           FIELDS WdCust->CustNo,WdCust->Name,WdOrdH->Orderno, ;
                  WdOrdH->Date, WdOrdH->Net ;
           HEADERS "Number","Name","Order;No","Order;Date","Order;Total" ;
           VSCROLL HSCROLL ;
           NOBAR ;
           MESSAGE "Select Customer Order"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 3 ;
           ACTION {|| oDlg:end() } ;
           CAPTION "Close" ;
           MESSAGE "Push Here to Exit"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 14 ;
           WHEN ! (oOrdHdr:eof()) ;
           ACTION {|| PrtReport(oBrw)} ;
           CAPTION "Print" ;
           MESSAGE "Push Here to Print Customer Order List"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 25 ;
           WHEN ! (oOrdHdr:eof()) ;
           ACTION {|| WDDOrdData(.F.) } ;
           CAPTION "Modify" ;
           MESSAGE "Push Here to Modify Selected Order"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 36 ;
           ACTION {|| WDDOrdData(.T.),oDlg:refresh,oBrw:gotop(),oBrw:refresh() } ;
           CAPTION "Add" ;
           MESSAGE "Push Here to Add New Customer Order"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 47 ;
           ACTION {|| DelOrd(),oDlg:refresh(), oBrw:gotop(), oBrw:refresh() } ;
           WHEN ! (oOrdHdr:eof()) ;
           CAPTION "Delete" ;
           MESSAGE "Push Here to Delete Selected Customer Order"

      oOrdHdr:select()

      ACTIVATE DIALOG oDlg CENTERED
      CLOSE DATABASES
   RETURN

STATIC PROCEDURE PrtReport(oBrw)
      IF ReportDlg("Order List") = 1
        oBrw:report("Order List",35,PrtReset,PrtOrient,PrtPitch,PrtLPI)
      ENDIF
   RETURN

PROCEDURE WDDOrdData( lNew )
   LOCAL oDlg, oItems, cTitle
   LOCAL cBtn1, cBtn2, aShipBy
      nTotalOrd := nTotalDisc := nNetOrder := 0
      IF lNew
        cTitle := "Add Customer Order"
        oOrdHdr:empty()
        oOrdHdr:date := Date()
        oCustData:empty()
        oTerms:empty()
        oDisc:empty()
        // Filter out all order detail records for the initial display
        //   this is a brute method of filtering out all records
        //   We'll be setting the correct filter in SaveHdr()
        oOrdDetl:select()
        SET FILTER TO WdOrdD->custno = Space(5)
        oOrdDetl:gotop()
      ELSE
        cTitle := "Modify Customer Order"
        oCustData:load()
        oTerms:load()
        oDisc:load()
        oOrdHdr:load()
        // Total the order as it is now
        CalcTotals()

        // Set the customer number and order for the details
        oOrdDetl:custno  := oOrdHdr:custno
        oOrdDetl:orderno := oOrdHdr:orderno
      ENDIF

      aShipBy := { { "            "," " }, ;
                   { "Pony Express","1" }, ;
                   { "Bus         ","2" }, ;
                   { "Train       ","3" }, ;
                   { "Slow Boat   ","4" }, ;
                   { "Dog Sled    ","5" }  }

      DEFINE DIALOG oDlg ;
         FROM 0,0 TO 20,66 ;
         TITLE cTitle ;
         SYSMENU

      DEFINE GET VAR oOrdHdr:CustNo OF oDlg;
         AT 2,10 ;
         COLOR "N/W, W+/B" ;
         WHEN ( lNew ) ;
         VALID CheckCust(oDlg) ;
         CAPTION "Cust No:" ;
         MESSAGE "Enter the Customer Number for Sold To"

      DEFINE SAY VAR oCustData:Name OF oDlg ;
         AT 3,10 ;
         COLOR "N/W,R/W" ;
         CAPTION "Sold To:"

      DEFINE SAY VAR oCustData:address OF oDlg ;
         AT 4,10 ;
         COLOR "N/W,R/W"

      DEFINE SAY VAR oCustData:city OF oDlg;
         AT 5,10 ;
         COLOR "N/W,R/W"

      DEFINE SAY VAR oCustData:prov OF oDlg ;
         AT 6,10 ;
         COLOR "N/W,R/W"

      DEFINE SAY VAR oCustData:postcode OF oDlg ;
         AT 6,15 ;
         COLOR "N/W,R/W"

      DEFINE SAY VAR oTerms:desc OF oDlg ;
         AT 3,45 ;
         COLOR "N/W,R/W" ;
         CAPTION "Terms:"

      DEFINE SAY VAR oDisc:desc OF oDlg ;
         AT 4,45 ;
         COLOR "N/W,R/W" ;
         CAPTION "Discount:"

      DEFINE SAY VAR oOrdHdr:date OF oDlg ;
         AT 5,45 ;
         COLOR "N/W,R/W" ;
         CAPTION "Date:"

      DEFINE GET VAR oOrdHdr:orderno OF oDlg ;
         AT 2,45 ;
         COLOR "N/W,W+/B" ;
         WHEN ( lNew ) ;
         VALID SaveHdr( @lNew ) ;
         CAPTION "Order No:" ;
         MESSAGE "Enter the Customer's Order Number"

      DEFINE CHECKBOX VAR oOrdHdr:pickup OF oDlg ;
         AT 7,45 ;
         ON CHANGE {|| oOrdHdr:shipby := Space(1), oDlg:refresh() } ;
         CAPTION "Pick Up" ;
         MESSAGE "Check if order is to be picked up by Customer"

      DEFINE COMBOBOX VAR oOrdHdr:shipby OF oDlg ;
         FROM  9,45 TO 16,60 ;
         ITEMS aShipBy ;
         WHEN !( oOrdHdr:pickup ) ;
         CAPTION "Ship By:" ;
         MESSAGE "Select Shipping Method " ;
         SCROLLBAR

      DEFINE PUSHBUTTON VAR cBtn1 OF oDlg ;
         AT 0, 45 ;
         ACTION SaveHdr( @lNew ) ;
         CAPTION "Save" ;
         MESSAGE "Push Here to Save Customer Information"

      **************************************************************
      *  NOVALIDATE on the next DEFINE means that if clicked,      *
      *    VALID clauses on pending get will not be executed       *
      *  This is great to bypass the valid when an exit from the   *
      *    the dialog is desired with further processing           *
      **************************************************************

      DEFINE PUSHBUTTON VAR cBtn1 OF oDlg ;
         AT 0, 3 ;
         NOVALIDATE ;
         ACTION {|| oDlg:end() } ;
         CAPTION "Close" ;
         MESSAGE "Push Here to Exit"

      **************************************************************
      * The following are the statements used to set up the TGet   *
      * for the order items.                                       *
      **************************************************************
      DEFINE TGET oItems OF oDlg ;
         FROM 11,5 TO 16,60 ;
         TABLE oOrdDetl ;
         NODELETE ;
         MESSAGE "Press Enter to Edit"

      DEFINE FIELD Partno OF oItems ;
         TABLE oOrdDetl ;
         CAPTION "Part #" ;
         COLOR "N/W,GR+/R" ;
         MESSAGE "Enter Part Number Ordered" ;
         VALID CheckItem()

      DEFINE FIELD Qty OF oItems ;
         TABLE oOrdDetl ;
         CAPTION "Qty" ;
         COLOR "N/W,GR+/R" ;
         PICTURE "999" ;
         MESSAGE "Enter Quantity Ordered" ;
         VALID CalcLine(oDlg)

      DEFINE FIELD Desc OF oItems ;
         TABLE oInvent ;
         CAPTION "Description" ;
         COLOR "N/W,GR+/R" ;
         WHEN (.F.)

      DEFINE FIELD Unitprice OF oItems ;
         TABLE oInvent ;
         CAPTION "Price" ;
         COLOR "N/W,GR+/R" ;
         WHEN (.F.)

      DEFINE FIELD Total OF oItems ;
         TABLE oOrdDetl ;
         CAPTION "Amount" ;
         PICTURE "99999.99" ;
         COLOR "N/W,GR+/R" ;
         WHEN (.F.)

      INITIALIZE TGET oItems OF oDlg

      **************************************************************
      * These SAY defines are to display the order totals at the   *
      * bottom of the form                                         *
      **************************************************************
      DEFINE SAY VAR nTotalOrd OF oDlg;
         AT 18,10 ;
         COLOR "N/W, N/W" ;
         CAPTION "Total:" ;
         PICTURE "99999.99" ;
         FRAME

      DEFINE SAY VAR nTotalDisc OF oDlg;
         AT 18,35 ;
         COLOR "N/W, N/W" ;
         CAPTION "Discount:" ;
         PICTURE "99999.99" ;
         FRAME

      DEFINE SAY VAR nNetOrder OF oDlg;
         AT 18,55 ;
         COLOR "N/W, N/W" ;
         CAPTION "Net:" ;
         PICTURE "99999.99" ;
         FRAME

      oOrdHdr:select()

      ACTIVATE DIALOG oDlg CENTERED

      oOrdHdr:select()
      oBrw:refresh()

   RETURN

/***
* ==========================================
* Miscellaneous Routines used by this module
* ==========================================
***/

STATIC FUNCTION CalcLine(oDlg)
   LOCAL lSuccess := .T.
      oOrdDetl:total := oOrdDetl:qty * oInvent:unitprice
      // Take away the previously saved total
      nTotalOrd -= WdOrdD->total
      // Now add in the new total
      nTotalOrd += oOrdDetl:total
      nTotalDisc := ( WdDisc->percent * nTotalOrd ) / 100
      nNetOrder := nTotalOrd - nTotalDisc
      oOrdHdr:Net := nNetOrder
      oOrdHdr:save()
      oDlg:refresh()
   RETURN ( lSuccess )

STATIC PROCEDURE CalcTotals()
      oOrdDetl:select()
      SET FILTER TO WdOrdD->Custno = oOrdHdr:custno .AND. ;
                    WdOrdD->OrderNo = oOrdHdr:Orderno
      oOrdDetl:gotop()
      WHILE !( oOrdDetl:eof() )
        oOrdDetl:load()
        nTotalOrd += oOrdDetl:total
        oOrdDetl:skip()
      ENDDO
      oOrdDetl:gotop()
      oOrdDetl:load()
      nTotalDisc := Round(( WdDisc->percent * nTotalOrd ) / 100,2)
      nNetOrder := nTotalOrd - nTotalDisc
      oOrdHdr:Net := nNetOrder
      oOrdHdr:save()
   RETURN

STATIC FUNCTION SaveHdr( lNew )
   LOCAL lSuccess := .T.
      IF !( lNew )
        oOrdHdr:save()
        oOrdDetl:custno  := oOrdHdr:custno
        oOrdDetl:orderno := oOrdHdr:orderno
      ELSEIF oOrdHdr:seek( oOrdHdr:custno + oOrdHdr:orderno )
        MsgBeep()
        MsgOk("Customer Order Number","Order Number Already Used;;for this Customer")
        lSuccess := .F.
      ELSE
        // Create a new Order Header record
        oOrdHdr:append()
        oOrdHdr:save()
        oOrdDetl:custno  := oOrdHdr:custno
        oOrdDetl:orderno := oOrdHdr:orderno

        // We don't want to have appends once we have created the
        // the new record.
        lNew := .F.

        // Set filter condition for details
        oOrdDetl:select()
        SET FILTER TO WdOrdD->Custno = oOrdHdr:custno .AND. ;
                      WdOrdD->OrderNo = oOrdHdr:Orderno
        oOrdDetl:gotop()
      ENDIF
   RETURN ( lSuccess )

STATIC FUNCTION CheckItem()
   LOCAL lSuccess := .T.
      IF Empty( oOrdDetl:partno) .AND. LastKey() = K_UP
      ELSEIF !( oInvent:seek(oOrdDetl:partno) )
        MsgBeep()
        MsgOk("Customer Order Detail","Item Number Not in Inventory")
        lSuccess := .F.
      ELSE
        oInvent:load()
      ENDIF
   RETURN ( lSuccess )

STATIC FUNCTION CheckCust(oDlg)
   LOCAL lSuccess := .T., nCurrRec := oCustData:recno()
      IF !( oCustData:seek(oOrdHdr:custno) )
        MsgBeep()
        MsgStop("Customer Order Detail","Customer Number Not Recorded")
        lSuccess := .F.
        oCustData:goto( nCurrRec )
      ELSE
        oCustFin:load()
        IF oCustFin:balance >= oCustFin:limit
          MsgBeep()
          MsgStop("Customer Order Detail","Customer Credit Limit has;;"+;
                                          "been exceeded.")
          lSuccess := .F.
        ELSE
          // Load the customer data and show it
          oCustData:load()
          oTerms:load()
          oCustFin:load()
          oDisc:load()
          oDlg:refresh()
        ENDIF
      ENDIF
   RETURN ( lSuccess )

STATIC FUNCTION DelOrd()
      MsgTone()
      IF MsgOkCan("Delete Order","Delete this Order") = BOX_REPLY_OKAY
        oOrdHdr:load()
        oOrdHdr:delete()
        oOrdDetl:seek( oOrdHdr:custno + oOrdHdr:orderno )
        WHILE WdOrdD->custno+WdOrdD->orderno = oOrdDetl:custno+oOrdDetl:orderno
          oOrdDetl:delete()
          oOrdDetl:skip()
        ENDDO
        MsgFlash("Delete Order","Order Deleted")
      ENDIF

   RETURN ( NIL )
